;------------------------------------------------------------------------------
; File Name :      act.asm
;------------------------------------------------------------------------------
;      Copyright: Eugene M. Hutorny  2006
;      Revision:  V1.00
;      Date:      Oct 21, 2006
;      License:   Licensed to public under the Open Software License 
;                 http://www.opensource.org/licenses/osl-3.0.php
;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------
; Discrete Actuator implementation
; 
;------------------------------------------------------------------------------
#define __act_asm
 include "pic.inc"
 include "vos.inc"
 include "act.inc"

;------------------------------------------------------------------------------
VOS_Classes             ; Actuator class dispatch table
ACT VOS_mClass ACT_Handler, ACT_Init
;------------------------------------------------------------------------------

 constant act_cPortAddrOff = 0
 constant act_cPortMaskOff = .1

act_mLoadPort macro
    bankisel    PORTA
    PDO_mReadObjData act_cPortAddrOff
 endm

act_mLoadMask macro
    PDO_mReadObjData act_cPortMaskOff
 endm

;------------------------------------------------------------------------------
ACT_code code
;------------------------------------------------------------------------------
ACT_Handler
    movlw       ACT_cMsgIDActuate
    xorwf       INDF, W
    skpz
    return
    incf        FSR, F          ; FSR = & value
    movfw       INDF
    bz          act_DoOff
    xorlw       ACT_cValueON
    bz          act_DoOn
    xorlw       ACT_cValueON ^ ACT_cValueALT
    skpz
    return
act_DoAlt
    call        act_LoadPort
    xorwf       INDF, F
    return
act_DoOn
    call        act_LoadPort
    iorwf       INDF, F
    return
act_DoOff
    call        act_LoadPort
    xorlw       0FFh
    andwf       INDF, F
    return
;------------------------------------------------------------------------------
act_LoadPort
    _pic_bankinit
    act_mLoadPort
    movwf       FSR
    act_mLoadMask
    return
;------------------------------------------------------------------------------
ACT_Init
    _pic_bankinit
    act_mLoadPort
    movwf       FSR
    act_mLoadMask
    xorlw       0FFh
    andwf       INDF, F
    pic_mPortToTris
    act_mLoadMask
    xorlw       0FFh
    andwf       INDF, F
    return
 end

