;------------------------------------------------------------------------------
; File Name :      hla.inc
;------------------------------------------------------------------------------
;      Copyright: Eugene M. Hutorny  2006
;      Revision:  V1.00
;      Date:      Oct 21, 2006
;      License:   Licensed to public under the Open Software License 
;                 http://www.opensource.org/licenses/osl-3.0.php
;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------
; Hall Light Automaton interface
; 
;------------------------------------------------------------------------------
#define __hla_inc
 ifndef __pdd_inc
    include "pdd.inc"
 endif
 ifdef __hla_asm
   implementation
 else
   interface
 endif
;------------------------------------------------------------------------------

 public HLASW           ; Class handling plain switches
 public HLAPB           ; Class handling push-buttons 
 public HLATB			; Class handling toggle-buttons
; Constructor parameter - eeprom address of constructor data
; Constructor data:
;   struct hla_object {
;       handle    alt_acceptor;      //1. handle of the actuator object (ALT is sent here)
;       handle    off_acceptor; }    //2. handle of the message delay object (OFF is sent here)
HLA_mData macro alt_acceptor, off_acceptor
    PDD_mData alt_acceptor
    de low off_acceptor
 endm
;------------------------------------------------------------------------------
