;------------------------------------------------------------------------------
; File Name :      ppi.inc
;------------------------------------------------------------------------------
;      Copyright: Eugene M. Hutorny  2006
;      Revision:  V1.00
;      Date:      Oct 25, 2006
;      License:   Licensed to public under the Open Software License 
;                 http://www.opensource.org/licenses/osl-3.0.php
;------------------------------------------------------------------------------
; PDO - Process Data Object 
; An abstract class
;------------------------------------------------------------------------------
; PPI - Potentiometer Parameter Input interface
; 
;------------------------------------------------------------------------------
#define __ppi_inc
 ifndef __pdd_inc
    include "pdd.inc"
 endif
 ifdef __ppi_asm
   implementation
 else
   interface
 endif
;------------------------------------------------------------------------------

 public PPI
; Constructor parameter - eeprom address of constructor data
; Constructor data:
;   struct ppi_object {
;       byte    acceptor;       //1. acceptor object as a VOS object pointer
;       byte    msgid;          //2. message ID to be sent
;       byte    channel;}       //3. ADC channel number
PPI_mData macro acceptor, msgid, channel
    PDD_mData acceptor
    de low msgid, low channel
 endm

;------------------------------------------------------------------------------

; struct ppi_message {
;       byte    valueL;         // 16-bit value
;       byte    valueH;
;}
