;------------------------------------------------------------------------------
; File Name :      vtm0_m.inc
;------------------------------------------------------------------------------
;      Copyright: Eugene M. Hutorny  2006
;      Revision:  V1.01
;      Date:      Nov 18, 2006
;      License:   Licensed to public under the Open Software License 
;                 http://www.opensource.org/licenses/osl-3.0.php
;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------
; VELOOS TMR0 Timer internal macro
;------------------------------------------------------------------------------

;------------------------------------------------------------------------------
 constant vtm0_tps    = .1000               ; ticks per second
;------------------------------------------------------------------------------
 if _osc_clock == 0
   error "_osc_clock is not properly set, please check configuration file"
 endif

 ifndef TMR0
TMR0    equ    TMR0L
 endif
 ifndef PS0
PS0     equ     T0PS0
PS1     equ     T0PS1
PS2     equ     T0PS2
 endif

; Calculating postscaler and prescaler
 variable vtm0_cPrescaler   = .4            ; Default prescaler
 variable vtm0_cTMR0Period  = _osc_clock / (.4 * vtm0_tps * vtm0_cPrescaler)

 if vtm0_cTMR0Period > .255
vtm0_cTMR0Period = .250
vtm0_cPrescaler  = _osc_clock / (.4 * vtm0_tps * vtm0_cTMR0Period)
 endif

 variable vtm0_T0PSA
 if vtm0_cPrescaler > .130
vtm0_cPrescaler     = .256
vtm0_T0PSA          = B'111'
 else 
  if vtm0_cPrescaler > .65
vtm0_cPrescaler     = .128
vtm0_T0PSA          = B'110'
  else
  if vtm0_cPrescaler > .32
vtm0_cPrescaler     = .64
vtm0_T0PSA          = B'101'
  else
  if vtm0_cPrescaler > .16
vtm0_cPrescaler     = .32
vtm0_T0PSA          = B'100'
  else
  if vtm0_cPrescaler > .8
vtm0_cPrescaler     = .16
vtm0_T0PSA          = B'011'
  else
  if vtm0_cPrescaler > .4
vtm0_cPrescaler     = .8
vtm0_T0PSA          = B'010'
  else
  if vtm0_cPrescaler > .2
vtm0_cPrescaler     = .4
vtm0_T0PSA          = B'001'
  else
vtm0_cPrescaler     = .2
vtm0_T0PSA          = B'000'
  endif
 endif
 endif
 endif
 endif
 endif
 endif
vtm0_cTMR0Period    = _osc_clock / ( .4 * vtm0_cPrescaler * vtm0_tps )
 if (vtm0_cTMR0Period > .255) || (vtm0_cTMR0Period == 0)
     error "Can not setup TMR0 prescaler and period for " vtm0_msPerTick "ms, clock " _osc_clock Hz  
 endif
 constant vtm0_cT0CON = (vtm0_T0PSA << PS0)
 variable vtm0_error = vtm0_tps - (_osc_clock / ( .4 * vtm0_cPrescaler *  vtm0_cTMR0Period))
 if vtm0_error != 0
    messg Timer 0 period is set with vtm0_error error 
 endif

 variable vtm0_cTMR0 = -(vtm0_cTMR0Period -1)
 ifndef T0CON
T0CON equ OPTION_REG
 endif
