;------------------------------------------------------------------------------
; File Name :      vtm2.asm
;------------------------------------------------------------------------------
;      Copyright: Eugene M. Hutorny  2006
;      Revision:  V1.00
;      Date:      Sep 2, 2006
;      License:   Licensed to public under the Open Software License 
;                 http://www.opensource.org/licenses/osl-3.0.php
;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------
; VELOOS Timer driver based on TMR2
; 
;------------------------------------------------------------------------------

#define __vtm2_asm
 include "pic.inc"
 include "vos.inc"
 include "vtm2.inc"
 include "vtm2_m.inc"

;------------------------------------------------------------------------------
; Timer data
vtm2 udata
vtmr_timems         res 2
 if VTMR_c1sTimer
vtmr_times          res 2
vtmr_countms        res 2
 endif
VOS_Classes
VTMR2 VOS_mClass VTM2_Handler, VTM2_Init

VOS_Objects
VTMR VOS_mPersistentObject VTMR2, TMR2

VTM2 code
  
VTM2_Init
    _pic_bankinit
    _pic_banksel PR2
    loadf   PR2, vtm2_cTMR2Period - .1
    _pic_banksel T2CON
    loadf   T2CON, vtm2_cT2CON
    _pic_banksel TMR2
    clrf    TMR2
    _pic_banksel T2CON
    bsf     T2CON, TMR2ON
    _pic_banksel PIE1
    bsf     PIE1, TMR2IE
    ifdef IPR1
    bcf     IPR1, TMR2IP           ; TMR2 is a low-level interrupt
    endif
    banksel vtmr_timems
    clrf    vtmr_timems
    clrf    vtmr_timems+1
    ifdef vtmr_countms
    loadf16 vtmr_countms, .1000 + .256  ; see explanation around vtm2_1ms
    endif
    ifdef   vtmr_times
    clrf    vtmr_times
    clrf    vtmr_times+1
    endif
    return

VTM2_Handler
    if VTMR_c1sTimer
    switch      INDF
    case        VTMR_cMsgIDTimer1ms, vtm2_1ms
    return
vtm2_1ms
    banksel     vtmr_countms
    decfsz      vtmr_countms, F
    return
    decfsz      vtmr_countms+1,F        ; this will end 256 ticks earlier
    return                              ; corrected by adding 256 to 1000
    loadf16 vtmr_countms, .1000 + .256  ; see explanation around vtm2_1ms
    infsnz      vtmr_times, F
    incf        vtmr_times+1, F
_1  VOS_mBroadcastMsg VTMR_cMsgIDTimer1s
    movff       vtmr_times, INDF
    incf        FSR, F
    movff       vtmr_times+1, INDF
    endif
    return           

VOS_Interrupt7 code                     ; low level interrupt
    _sfr_banksel     PIR1
    btfss       PIR1, TMR2IF
    bra         vtm2_notTMR2
    banksel     vtmr_timems
    infsnz      vtmr_timems, F
    incf        vtmr_timems+1, F
    VOS_mBroadcastMsg VTMR_cMsgIDTimer1ms
    banksel     vtmr_timems
    movff       vtmr_timems, INDF
    incf        FSR, F
    movff       vtmr_timems+1, INDF
    _sfr_banksel     PIR1
    bcf         PIR1, TMR2IF
   if VOS_cEnableSoftWDT
    btfsc       VOS_bSoftWDT
    extern      vos_Timeout
    bra         vos_Timeout
    bsf         VOS_bSoftWDT
   endif
vtm2_notTMR2 
 END
