;------------------------------------------------------------------------------
; File Name :      vtm2_m.inc
;------------------------------------------------------------------------------
;      Copyright: Eugene M. Hutorny  2006
;      Revision:  V1.00
;      Date:      Sep 25, 2006
;      License:   Licensed to public under the Open Software License 
;                 http://www.opensource.org/licenses/osl-3.0.php
;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------
; VELOOS TMR2 Timer internal macro
;------------------------------------------------------------------------------

;------------------------------------------------------------------------------
 constant vtm2_tps    = .1000               ; ticks per second
;------------------------------------------------------------------------------
 if _osc_clock == 0
   error "_osc_clock is not properly set, please check configuration file"
 endif

; Calculating postscaler and prescaler
 variable vtm2_cPostscaler  = .5            ; Default postscaler 
 variable vtm2_cTMR2Period  = .100          ; Default TMR2 period
 variable vtm2_cPrescaler   = _osc_clock / (.4 * vtm2_cTMR2Period * vtm2_tps * vtm2_cPostscaler)
 variable vtm2_T2CKPS1
 if vtm2_cPrescaler > .10                   ; Prescaler values 5-10 can work with period 125-250
vtm2_cPrescaler     = .16                   ; If prescaler > 10 have to use maximal
vtm2_T2CKPS1        = B'11'
 else 
  if vtm2_cPrescaler > .2
vtm2_cPrescaler     = .4
vtm2_T2CKPS1        = B'01'
  else
vtm2_cPrescaler     = .1
vtm2_T2CKPS1        = B'00'
  endif
 endif
vtm2_cTMR2Period    = _osc_clock / ( .4 * vtm2_cPostscaler * vtm2_cPrescaler * vtm2_tps )
 if (vtm2_cTMR2Period > .255) || (vtm2_cTMR2Period == 0)
vtm2_cTMR2Period = .256
vtm2_cPostscaler    = (_osc_clock / (.4 * vtm2_cTMR2Period * vtm2_cPostscaler * vtm2_tps ))
   if (vtm2_cPostscaler > .16) || (vtm2_cPostscaler == 0)
     error "Can not setup TMR2 prescaler and postscaler for " vtm2_msPerTick "ms, clock " _osc_clock Hz  
   endif
vtm2_cTMR2Period    = _osc_clock / ( .4 * vtm2_cPostscaler * vtm2_cPrescaler * vtm2_tps )
   if (vtm2_cTMR2Period > .255) || (vtm2_cTMR2Period == 0)
     error "Error calculating TMR2 period for " vtm2_msPerTick "ms, clock " _osc_clock Hz  
   endif 
 endif
 constant vtm2_cT2CON = (vtm2_T2CKPS1 << T2CKPS0) | ((vtm2_cPostscaler - .1) << TOUTPS0)
 variable vtm2_error = vtm2_tps - (_osc_clock / ( .4 * vtm2_cPostscaler * vtm2_cPrescaler *  vtm2_cTMR2Period))
 if vtm2_error != 0
    messg Timer 2 period is set with vtm2_error error 
 endif
